{** This unit implements the sound system.
It is actually almost empty, becouse i have yet to choose
a sound lib to use.
Some tests have been done with fmod, but i don't like it's license
and it's not being open source. }
unit disabledsoundunit;

(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.

*)


interface

uses Classes;

type
   TALint=integer;

  // useful compatibility with ode vectors
  // but works only as long as ODE single DLL is used
//  TAlVector3 = TdVector3;
  // use this if you dont' need ODE
  // TAlVector3 = array [0..2] of TALfloat;

  TSound = class
    name:string;
    buffer:TALInt;

    constructor Create(filename:string);
    destructor Destroy; override;
  end;

  TSource = class
   private
    source : TALint;
    function getPitch():single;
    procedure setPitch(v:single);
    function getGain():single;
    procedure setGain(v:single);
//    procedure setPosition(v:TAlVector3);
//    procedure setVelocity(v:TAlVector3);
    procedure setLoop(v:boolean);
    function getLoop():boolean;
   public
    property Pitch:single read getPitch write setPitch;
    property Gain:single read getGain write setGain;
    property Loop:boolean read getLoop write setLoop;
//    property Position:TAlVector3 write setPosition;
//    property Velocity:TAlVector3 write setVelocity;
    procedure Play;
    destructor Destroy; override;
    constructor Create(sound:TSound);
  end;

  TSoundList = class(TList)
      function getSound(index:integer):TSound;
      property Sound[index:integer]:TSound read getSound; default;
       function getSoundByName(name:string):TSound;
     end;


function InitSound:boolean;
procedure setListenerOrientation(atx,aty,atz,upx,upy,upz:integer);
//procedure setListenerPosition(v:TAlVector3);
//procedure setListenerVelocity(v:TAlVector3);

implementation
(*
procedure setListenerPosition(v:TAlVector3);
begin

end;
procedure setListenerVelocity(v:TAlVector3);
begin

end;
*)
procedure setListenerOrientation(atx,aty,atz,upx,upy,upz:integer);
begin
end;

destructor TSound.Destroy;
begin
end;

constructor TSound.Create(filename:string);
begin
end;

function InitSound:boolean;
begin
  result:=TRUE;
end;

function TSoundList.getSound(index:integer):TSound;
begin
result:=TSound(items[index]);
end;

function TSoundList.getSoundByName(name:string):TSound;
var i:integer;
begin
 for i:=0 to count-1 do
  if Sound[i].name=name then
  begin
   result:=Sound[i];
   exit;
  end;
 result:=nil;
end;

function TSource.getPitch():single;
begin
result:=0;
end;

procedure TSource.setPitch(v:single);
begin

end;


function TSource.getGain():single;
begin
result:=0;
end;

procedure TSource.setGain(v:single);
begin
end;

(*procedure TSource.setPosition(v:TAlVector3);
begin
end;

procedure TSource.setVelocity(v:TAlVector3);
begin
end;
  *)
destructor TSource.Destroy;
begin
end;

constructor TSource.Create(sound:TSound);
begin
end;

procedure TSource.setLoop(v:boolean);
begin
end;

function TSource.getLoop():boolean;
begin
result:=false;
end;

procedure TSource.Play;
begin
end;


end.
