unit fontunit;

interface

uses
  Classes, SysUtils, mediamanagerunit, sdl, gl, glu, globalunit, floatunit;

procedure drawRaceString(x,y:integer; s:string; scale:TFloat);

implementation


const WIDTH = 32;
      HEIGHT = 64;


procedure drawRaceChar(x,y:integer; c:char; scale:TFloat);
var tx,ty,w,h:single;
    i:byte;
begin
  if c=' ' then exit;
  i:=ord(C)-48;
  tx:=((i mod 8)*WIDTH)/256;
  ty:=((i div 8)*HEIGHT)/256;
  w := WIDTH/256;
  h := HEIGHT/256;

  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles
    glTexCoord2f(tx,ty);
    glVertex2f(  x,  y );
    
    glTexCoord2f(tx,ty+h);
    glVertex2f(  x,  y+HEIGHT*scale );

    glTexCoord2f(tx+w,ty);
    glVertex2f(  x+WIDTH*scale,  y );

    glTexCoord2f(tx+w,ty+h);
    glVertex2f(  x+WIDTH*scale,  y+HEIGHT*scale );
  glEnd;                            // Finished Drawing The Triangles

end;

procedure drawRaceString(x,y:integer; s:string; scale:TFloat);
var i:integer;
begin
  glColor3f(1,1,1);
  global.man.getTextureByName('numbers').bind;
  for i:=1 to length(s) do
   drawRaceChar(x+(i-1)*round(WIDTH*scale), y, s[i], scale);

end;


end.

